/* pixel.c
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023, 2024 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#include <assert.h>
#include <stdarg.h>
#include <stdbool.h>

#include "pixel.h"

Pixel pixel_default()
{
	return (Pixel) { {0, 0, 0, 0} };
}

void nan_pixel_assert(Pixel pixel)
{
	#ifdef DEBUG
	int i = 0;
	for(i = 0; i < 4; i += 1) {
		assert(pixel.rgb[i] >= 0 && pixel.rgb[i] <= 1); /* pixel.ngg:21 */
	}

	#endif
}

Pixel rgbpixel_with_alpha(Pixel pixel, double a)
{
	int i;
	nan_pixel_assert(pixel);
	assert(1 == pixel.rgb[3]); /* pixel.ngg:28 */
	for(i = 0; i < 3; i += 1) {
		pixel.rgb[i] = pixel.rgb[i] * a;
	}

	pixel.rgb[3] = a;
	nan_pixel_assert(pixel);

	return pixel;
}

